; ****************************************************************************
;       TITLE: DBOX2.sc
;     SESSION: PAOLINI - Interface Issues in Paradox 4
;   COPYRIGHT: (c) 1993 - Dan Paolini - DataStar International
; DESCRIPTION: Example of Dialog Box using 2nd Dialog Box for a Combo List
; ****************************************************************************
PROC QBDCorrActionHistoryOKDB.l(
         from.d,
         to.d,
         id.a)

  IF ISBLANK(from.d) THEN
    msContinue.u("FROM Date Cannot Be Blank",79,999,999,g.colorsred.y,1)
    SelectControl "FROM"
    RETURN FALSE
  ENDIF

  IF NOT ISBLANK(to.d) THEN
    IF from.d > to.d THEN
      msContinue.u("FROM Date Cannot Be Greater Than THROUGH Date",79,
                    999,999,g.colorsred.y,1)
      SelectControl "FROM"
      RETURN FALSE
    ENDIF     ;local global set in check report dates proc
  ENDIF

  IF ISBLANK(ID.a) THEN
    msContinue.u("Employee ID Cannot Be Blank",79,999,999,g.colorsred.y,1)
    SelectControl "ID"
    RETURN FALSE
  ENDIF

  Qid.a=Id.a
  Qfrom.d=from.d

  IF ISBLANK(to.d) THEN
    QTo.d=from.d
  ELSE
    Qto.d=to.d
  ENDIF

  AcceptDialog
  RETURN TRUE
ENDPROC
; ----------------------------------------------------------------------------
PROC QBDCorrActionHistory.l()
Private  butvar.l,
         From.d,
         To.d

  Butvar.l = false
  id.a=""
  from.d=Blankdate()
  to.d=Blankdate()


  SHOWDIALOG "Corrective Action History Report"
      PROC "ComboBox.l" KEY -80, -59
     @6,15 HEIGHT 14 WIDTH 48

     FRAME SINGLE FROM 0,1 TO 8,44
     PAINTCANVAS ATTRIBUTE 112 0,1,0,44
     PAINTCANVAS ATTRIBUTE 112 0,1,8,1
     PAINTCANVAS ATTRIBUTE 127 8,2,8,44
     PAINTCANVAS ATTRIBUTE 127 0,44,8,44

     @2,4
     ?? "Select Date From:"
     PAINTCANVAS ATTRIBUTE 112 2,4,2,20

     @4,13
     ?? "Through:"
     PAINTCANVAS ATTRIBUTE 112 4,13,4,20

     @6,9
     ?? "Employee ID:"
     PAINTCANVAS ATTRIBUTE 112 6,9,6,20
     @6,31
     ?? ""
     PAINTCANVAS ATTRIBUTE 116 6,31,6,31

     ACCEPT @2,22 WIDTH 13
        "d"
        TAG "FROM"
        TO From.d

     ACCEPT @4,22 WIDTH 13
        "D"
        TAG "TO"
        TO To.d

     ACCEPT @6,22 WIDTH 9
        "A6"
        PICTURE "######"
        MIN "000000"
        MAX "999999"
        TAG "ID"
        TO ID.a

     PUSHBUTTON @10,8 WIDTH 11
        "~O~k"
        OK
        VALUE  "OK"
        TAG "PRINT"
        TO butvar.l

     PUSHBUTTON @10,27 WIDTH 11
        "~C~ancel"
        CANCEL
        VALUE FALSE
        TAG "CANCEL"
        TO butvar.l

  ENDDIALOG
    Return Butvar.l
EndProc

PROC ComboBox.l(a,tag.a,c,d)

   picklist.n = 1
   IF tag.a = "ID" THEN
      Array id.r[8]
         id.r[1] = "111111 - Bob Smith"
         id.r[2] = "222222 - Mary Jones"
         id.r[3] = "333333 - John Donson"
         id.r[4] = "444444 - Ann Weaver"
         id.r[5] = "555555 - Zack Aaron"
         id.r[6] = "666666 - Linda Martin"
         id.r[7] = "777777 - Tom Turner"
         id.r[8] = "888888 - Julie Burton"
      SHOWDIALOG ""
         PROC "ComboBoxDB.l" KEY 13,27 TRIGGER "OPEN"
         @13,36 HEIGHT 8 WIDTH 28
         PickArray @0,1 Height 6 Width 24
            Columns 1
            id.r
            Tag "COMBO"
            To combo.n
      ENDDIALOG
      IF retval THEN
         id.a = SubStr(id.r[combo.n],1,6)
         ResyncControl "ID"
      ENDIF
   ENDIF
ENDPROC

PROC ComboBoxDB.l(a,b,c,d)
   IF a = "OPEN" THEN
      Window Handle Dialog To h
      DynArray y[]
         y["HASFRAME"] = false
      Window SetAttributes h From y
   ELSE
      IF c["KEYCODE"] = 27 THEN
         CANCELDIALOG
      ELSE
         ACCEPTDIALOG
      ENDIF
   ENDIF
ENDPROC

QBDCorrActionHistory.l()
