; ****************************************************************************
;       TITLE: MENU2.sc
;     SESSION: PAOLINI - Interface Issues in Paradox 4
;   COPYRIGHT: (c) 1993 - Dan Paolini - DataStar International
; DESCRIPTION: Example of Dialog Box-based Menu
;              Generic routines are in the script "DS4_UTIL"
; ****************************************************************************
Cursor OFF
PROC RefreshMenu.l(a,b,c,d)
   IF a = "EVENT" THEN
      SWITCH
         CASE c["TYPE"] = "IDLE" : Sleep 100
         CASE c["TYPE"] = "KEY"  :
            SWITCH
               CASE c["KEYCODE"] = -72 AND menutag.n = 1 AND b = "PICKLIST" :
                  menutag.n = 6
               CASE c["KEYCODE"] = -80 AND menutag.n = 6 AND b = "PICKLIST" :
                  menutag.n = 1
               CASE c["KEYCODE"] = 27  :
               OTHERWISE               :
                  SelectControl "PICKLIST"
                  Return true
            ENDSWITCH
            ResyncControl "PICKLIST"
            Return false
      ENDSWITCH
   ELSE
      IF a = "OPEN" THEN
         Window Handle Dialog To h
         DynArray y[]
            y["HASFRAME"] = false
         Window SetAttributes h From y
      ENDIF
   ENDIF
   RepaintDialog
ENDPROC

   GetColors to democolors.y
   DynArray dboxcolors.y[]
      dboxcolors.y["1056"] = 112
      dboxcolors.y["1057"] = 31
      dboxcolors.y["1058"] = 31
   SetColors from dboxcolors.y

   Array menuitems.r[6]
      menuitems.r[1] = "This is the first menu selection"
      menuitems.r[2] = "This is the second menu selection"
      menuitems.r[3] = "This is the third menu selection"
      menuitems.r[4] = "This is the fourth menu selection"
      menuitems.r[5] = "This is the fifth menu selection"
      menuitems.r[6] = "This is the last one"
   Array menuprompts.r[6]
      menuprompts.r[1] = "Example of a menu prompt for item #1"
      menuprompts.r[2] = "Example of a menu prompt for item #2"
      menuprompts.r[3] = "Example of a menu prompt for item #3"
      menuprompts.r[4] = "Example of a menu prompt for item #4"
      menuprompts.r[5] = "Example of a menu prompt for item #5"
      menuprompts.r[6] = "Example of a menu prompt for item #6"
   menutag.n = 1


   ShowDialog "Demonstration Dialog Box Menu"
      PROC "RefreshMenu.l"
         KEY -72, -80, 27
         IDLE
         TRIGGER "UPDATE", "OPEN"
      @2,17 Height 20 Width 45

      Frame Single From 14,1 To 17,41
      PaintCanvas Attribute 127 14,1,14,41
      PaintCanvas Attribute 127 14,1,17,1
      PaintCanvas Attribute 112 17,2,17,41
      PaintCanvas Attribute 112 14,41,17,41

      Frame Single From 0,1 To 7,41
      PaintCanvas Attribute 112 0,1,0,41
      PaintCanvas Attribute 112 0,1,7,1
      PaintCanvas Attribute 127 7,2,7,41
      PaintCanvas Attribute 127 0,41,7,41

      Frame Single From 8,1 To 10,41
      PaintCanvas Attribute 127 8,1,8,41
      PaintCanvas Attribute 127 8,1,10,1
      PaintCanvas Attribute 112 10,2,10,41
      PaintCanvas Attribute 112 8,41,10,41

      PaintCanvas Fill " " Attribute 112 15,6,15,16
      @15,6
      ?? "User Name:"
      PaintCanvas Attribute 112 15,6,15,16

      PaintCanvas Fill " " Attribute 112 16,6,16,16
      @16,6
      ?? "Date/Time:"
      PaintCanvas Attribute 112 16,6,16,16

      PaintCanvas Fill " " Attribute 127 15,18,15,36
      @15,18
      ?? "TOSH4400"
      PaintCanvas Attribute 127 15,18,15,36

      PaintCanvas Fill " " Attribute 127 16,18,16,36
      @16,18
      ?? Format("w10,al,d1",Today()) + Time()
      PaintCanvas Attribute 127 16,18,16,36

      PaintCanvas Fill " " Attribute 112 9,3,9,39
      @9,3
      ?? menuprompts.r[menutag.n]
      PaintCanvas Attribute 113 9,3,9,39

      PickArray @1,4 Height 6 Width 35
         Columns 1
         menuitems.r
         Tag "PICKLIST"
         To menutag.n

      PushButton @12,2 Width 8
         "~H~elp"
         Value "HELP"
         Tag "BUTTON"
         To button.a

      PushButton @12,14 Width 15
         "~S~ystem Menu"
         Value "SYSTEM"
         Tag "BUTTON"
         To button.a

      PushButton @12,33 Width 8
         "~E~xit"
         Cancel
         Value "EXIT"
         Tag "BUTTON"
         To button.a
   EndDialog
   SetColors from democolors.y
   Release VARS ALL
